// API name: ReferenceManagementServiceAPI

type PaperitemId {
	anonymous10: void { id: string /* data type role: D */ } 
}

type PaperItemDTO {
	anonymous8: void { title: string /* data type role: D */ authors: string /* data type role: D */ venue: string /* data type role: D */ paperitemId: PaperItemKey } 
}

type PaperItemKey {
	anonymous9: void { id: string /* data type role: D */ } 
}

type PaperItem {
	anonymous7: void { title: string /* data type role: D */ authors: string /* data type role: D */ venue: string /* data type role: D */ paperitemId: PaperitemId } 
}


// operation responsibility: RETRIEVAL_OPERATION
type lookupPapersFromAuthorRequestDTO {
	anonymous3: string /* data type role: D */ 
}

type lookupPapersFromAuthorResponseDTO {
	anonymous4[0,*]: PaperItemDTO 
}

// operation responsibility: STATE_CREATION_OPERATION
type createPaperItemRequestDTO {
	anonymous1: PaperItemDTO 
}

type createPaperItemResponseDTO {
	anonymous2: PaperItemKey 
}

// operation responsibility: undefined
type convertToMarkdownForWebsiteRequestDTO {
	anonymous5: PaperItemKey 
}

type convertToMarkdownForWebsiteResponseDTO {
	anonymous6: string /* data type role: D */ 
}


type SOAPFaultMessage {
	code: int
	text: string
	actor: string
	details: string
}


// interface/endpoint role: INFORMATION_HOLDER_RESOURCE
interface PaperArchiveFacade {
RequestResponse:
	createPaperItem( createPaperItemRequestDTO )( createPaperItemResponseDTO ),
	lookupPapersFromAuthor( lookupPapersFromAuthorRequestDTO )( lookupPapersFromAuthorResponseDTO ),
	convertToMarkdownForWebsite( convertToMarkdownForWebsiteRequestDTO )( convertToMarkdownForWebsiteResponseDTO ),
}

inputPort PaperArchiveFacadePort {
	location: "socket://localhost:8080" 
	protocol: soap
	interfaces: PaperArchiveFacade
}

// sample conversion to WSDL/SOAP:
// jolie2wsdl --namespace "http://tbc.org" --portName PaperArchiveFacadePort --portAddr "localhost:8080" --outputFile ReferenceManagementServiceAPIPaperArchiveFacade.wsdl ReferenceManagementServiceAPI.ol
// The WSDL could be viewed/analyzed at: https://www.wsdl-analyzer.com/upload


main
{
	nullProcess
}
